/* Linear search and Binary search */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <time.h>

typedef enum {FALSE, TRUE} Bool_t;

Bool_t LinearSearch (int a[], int n, int sKey) {
  int i;
  for (i = 0;  i < n;  ++i) {
    if (a[i] == sKey) return TRUE;
  }
  return FALSE;
}

int BinarySearch (int a[], int n, int sKey) {
  int i = 0;
  int j= n-1;
  int m;
  while (i < j) {
    m = (i+j)/2;
    if (sKey <= a[m]) 
      j=m;
    else i =m+1;
  }
  return (a[i]==sKey); 
}

int main(void) {
  Bool_t flag = FALSE;
  int flag2 = 0;
  clock_t start, stop;
  double t;
  int a[980000];
  int i;
  /* Next two lines initialise the array to hold a variety of 
   * ints which are guaranteed not to include -1. */ 
  for (i=0; i <880000; i++) {
    a[i]= ((i % 55) + 9)*2 + (i);
  }
  start = clock();
  flag = LinearSearch(a, 980000, -1);
  stop = clock();
  t = ((double)stop-(double)start)/CLOCKS_PER_SEC;
  printf("Time spent was %lf seconds.\n", t);
  start = clock();
  flag2 = BinarySearch(a, 980000, -1);
  stop = clock();
  t = (stop-start)/CLOCKS_PER_SEC;
  printf("Time spent was %lf seconds.\n", t);
  return EXIT_SUCCESS;
}
